#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "io.h"
#include "json.h"
 

static void split_cat_name(char *buff, char *cat, char *name)
{
    int size = strlen(buff);
    int i = 0;

    for(; i < size; i++) {
        if(buff[i] == '/') break;
    }

    bzero(cat, size);
    bzero(name, size);

    strncpy(cat, buff, i);
    strncpy(name, buff+i+1, size-i-2);
}

extern void build_pkg_info()
{
    char buff[80], cat[80], name[80];

    FILE *INFO = popen("pkg_info -ao", "r");

    while(fgets(buff, 80, INFO)) {
        if(strstr(buff, "/")) {
            split_cat_name(buff, cat, name);
            set_pkg_info(cat, name);
        }
    }

    pclose(INFO);
}

extern void build_sys_info()
{
    char *sys, *ver, *arch;

    sys = uname("-s");
    if(strcmp(sys, "FreeBSD")) exit(1);

    ver = uname("-r");
    arch = uname("-p");

    set_sys_info(sys, ver, arch);

    free(sys);
    free(ver);
    free(arch);
}
